class Pizza {
  def things = []
  
  def add(String[] ingredients) {
    things << ingredients
  }
  
  def getBake() {
    println 'baking...'
  }
  
  def propertyMissing(String name) { name }
} 

def create(klass, closure) {
  def instance = klass.newInstance()
  instance.with closure
  instance
}

pizza = 
create Pizza, {
  add sauce
  add cheese
  add Olives, Tomato, Onions
  bake
}

println pizza.things